#include "stdafx.h"
#include "spltestdlg.h"
#include "spltestdlgDlg.h"
#include "..\Splasher.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//Our simple derived Splash screen class, which just uses the bitmap resource IDB_SPLASH
class CMySplashWnd : public CSplashWnd
{
public:
//Constructors / Destructors
#pragma warning(suppress: 26455)
  CMySplashWnd()
  {
    //Lets use an almost opaque splash window with some "cut-out" sections in it
    SetBitmapToUse(IDB_SPLASH);
    SetDropShadow();
    SetTransparent(RGB(255, 0, 255), LWA_ALPHA, 224);
  }
  CMySplashWnd(const CMySplashWnd&) = delete;
  CMySplashWnd(CMySplashWnd&&) = delete;
  ~CMySplashWnd() = default; //NOLINT(modernize-use-override)

//Methods
  CMySplashWnd& operator=(const CMySplashWnd&) = delete;
  CMySplashWnd& operator=(CMySplashWnd&&) = delete;

protected:
  DECLARE_DYNCREATE(CMySplashWnd);
};

#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CMySplashWnd, CSplashWnd);


#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CSpltestdlgApp, CWinApp) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()

#pragma warning(suppress: 26426)
CSpltestdlgApp theApp;

BOOL CSpltestdlgApp::InitInstance()
{
  /////////////////// ADDED TO SUPPORT THE SPLASH SCREEN//////////////////////
  CSplashFactory factory;
  if (!factory.Create(RUNTIME_CLASS(CMySplashWnd)))
  {
    AfxMessageBox(_T("Failed to create splash screen"), MB_OK | MB_ICONSTOP);
    return FALSE;
  }
  ////////////////////////////////////////////////////////////////////////////


  CSpltestdlgDlg dlg;
  /////////////////// ADDED TO SUPPORT THE SPLASH SCREEN /////////////////////
  dlg.m_pSplashFactory = &factory;
  /////////////////// ADDED TO SUPPORT THE SPLASH SCREEN /////////////////////
  m_pMainWnd = &dlg;
  dlg.DoModal();

  return FALSE;
}
